/***************************************************************************
                          sndutil.h  -  description
                             -------------------
    begin                : Fri May 28 2004
    copyright            : (C) 2004 by Zhanglei Wang
    email                : filamoon@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

typedef struct sound_config
{
	SndCard *sndcard;	/* the sndcard currently used */
	gint dev_id;		/* sound device id */
	gint latency;	/* latency in samples of the current used sound device */
	char rec_lev;
	char play_lev;
	char source;
	char pad;
	char *local_ring;
	char *remote_ring;
	int autokill:1;  /* 1= automatically free access to sound device by killing artsd and esd*/
} sound_config_t;

int linphone_arts_suspend();
int linphone_arts_restore();
int kill_sound_daemons();
void restore_sound_daemons();
int try_open_dsp(sound_config_t *sound_conf);

void check_sound_device(SndCard *sndcard);

SndCardManager * gaim_mediastreamer_get_card_manager(sound_config_t *sound_conf);
gint gaim_mediastreamer_get_play_level(sound_config_t *sound_conf);
gint gaim_mediastreamer_get_rec_level(sound_config_t *sound_conf);
void gaim_mediastreamer_set_play_level(sound_config_t *sound_conf, gint level);
void gaim_mediastreamer_set_rec_level(sound_config_t *sound_conf, gint level);
gint gaim_mediastreamer_get_sound_device(sound_config_t *sound_conf);
gint gaim_mediastreamer_set_sound_device(sound_config_t *sound_conf, gint devid);
gint gaim_mediastreamer_set_sound_device_from_name(sound_config_t *sound_conf,gchar *name);
gchar gaim_mediastreamer_get_sound_source(sound_config_t *sound_conf);
void gaim_mediastreamer_set_sound_source(sound_config_t *sound_conf, gchar source);
