/*
  The mediastreamer library aims at providing modular media processing and I/O
	for linphone, but also for any telephony application.
  Copyright (C) 2001  Simon MORLAT simon.morlat@linphone.org
  										
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef MSAVENCODER_R263_H
#define MSAVENCODER_R263_H

#include "msfilter.h"
#include <avcodec.h>	/* will use its conversion code */
#include "../libr263/libr263.h"
#include "../libr263/rlib.h"
#undef PACKAGE
#undef VERSION
#include <ortp.h>

/*this is the class that implements a AVencoder filter*/
#define MSAVENCODER_MAX_INPUTS  1 /* max output per filter*/


struct _MSAVEncoder_R263
{
	/* the MSAVEncoder derivates from MSFilter, so the MSFilter object MUST be the first of the MSAVEncoder object
	in order to the object mechanism to work*/
	MSFilter filter;
	MSQueue *q_inputs[MSAVENCODER_MAX_INPUTS];
	MSQueue *q_outputs[MSAVENCODER_MAX_INPUTS];
	gint input_pix_fmt, pix_fmt, width, height;
	CParam cparams;
	Bits bits;
	int EncodeBlocks[9][11];
	int gop_length;
	guint frame_no;
	struct qcif qcif_frame;
	/* RtpSession * rtp_session; */
	/* gchar stream_buf[4096+1024]; */
	MSBuffer * msbuf;
};

typedef struct _MSAVEncoder_R263 MSAVEncoderR263;

struct _MSAVEncoderR263Class
{
	/* the MSAVEncoder derivates from MSFilter, so the MSFilter class MUST be the first of the MSAVEncoder class
       in order to the class mechanism to work*/
	MSFilterClass parent_class;
};

typedef struct _MSAVEncoderR263Class MSAVEncoderR263Class;

/* PUBLIC */
#define MS_AVENCODER_R263(filter) ((MSAVEncoderR263*)(filter))
#define MS_AVENCODER_R263_CLASS(klass) ((MSAVEncoderR263Class*)(klass))
MSFilter * ms_AVencoder_r263_new();
gint ms_AVencoder_r263_set_format(MSAVEncoderR263 *enc, gchar *fmt);
/* void ms_AVencoder_r263_set_rtp_session(MSAVEncoderR263 *enc, RtpSession * r); */

/* FOR INTERNAL USE*/
void ms_AVencoder_r263_init(MSAVEncoderR263 *r);
void ms_AVencoder_r263_uninit(MSAVEncoderR263 *enc);
void ms_AVencoder_r263_class_init(MSAVEncoderR263Class *klass);
void ms_AVencoder_r263_destroy( MSAVEncoderR263 *obj);
void ms_AVencoder_r263_process(MSAVEncoderR263 *r);
void ms_AVencoder_r263_toggle_rgb_bgr(MSAVEncoderR263 *r);

#endif