/*
  The mediastreamer library aims at providing modular media processing and I/O
	for linphone, but also for any telephony application.
  Copyright (C) 2001  Simon MORLAT simon.morlat@linphone.org
  										
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef MSRTPRECVH263_H
#define MSRTPRECVH263_H

#include "msrtprecv.h"

struct _MSRtpRecvH263
{
    MSRtpRecv rtpsend;
    MSQueue * frame_q;
    //guint32 last_ref;        //temporal reference of the last-sent frame
    guint32 cur_ref;         //current buffered frame ref
};

typedef struct _MSRtpRecvH263 MSRtpRecvH263;

struct _MSRtpRecvH263Class
{
	/* the MSCopy derivates from MSFilter, so the MSFilter class MUST be the first of the MSCopy class
       in order to the class mechanism to work*/
	MSRtpRecvClass parent_class;
};

typedef struct _MSRtpRecvH263Class MSRtpRecvH263Class;

/* PUBLIC */
#define MS_RTP_RECV_H263(filter) ((MSRtpRecvH263*)(filter))
#define MS_RTP_RECV_H263_CLASS(klass) ((MSRtpRecvH263Class*)(klass))
MSFilter * ms_rtp_recv_h263_new(void);



/* FOR INTERNAL USE*/
void ms_rtp_recv_h263_init(MSRtpRecvH263 *r);
void ms_rtp_recv_h263_class_init(MSRtpRecvH263Class *klass);
void ms_rtp_recv_h263_destroy( MSRtpRecvH263 *obj);
void ms_rtp_recv_h263_process(MSRtpRecvH263 *r);
void ms_rtp_recv_h263_setup(MSRtpRecvH263 *r,MSSync *sync);

#endif
