/*
  The mediastreamer library aims at providing modular media processing and I/O
	for linphone, but also for any telephony application.
  Copyright (C) 2001  Simon MORLAT simon.morlat@linphone.org
  										
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef MSRTPSENDH263_H
#define MSRTPSENDH263_H


#include "msrtpsend.h"

/*this is the class that implements an h263 sending through rtp filter*/

struct _MSRtpSendH263
{
    /* the MSRtpSendH263 derivates from MSRtpSend, so the MSRtpSend object MUST be the first of the MSRtpSend object
       in order to the object mechanism to work*/
    MSRtpSend rtpsend;
};

typedef struct _MSRtpSendH263 MSRtpSendH263;

struct _MSRtpSendH263Class
{
	/* the MSRtpSendH263 derivates from MSRtpSend, so the MSRtpSend class MUST be the first of the MSRtpSendH263 class
       in order to the class mechanism to work*/
	MSRtpSendClass parent_class;
};

typedef struct _MSRtpSendH263Class MSRtpSendH263Class;

/* PUBLIC */
#define MS_RTP_SEND_H263(filter) ((MSRtpSendH263*)(filter))
#define MS_RTP_SEND_H263_CLASS(klass) ((MSRtpSendH263Class*)(klass))
MSFilter * ms_rtp_send_h263_new(void);

void ms_rtp_send_h263_init(MSRtpSendH263 *r);
void ms_rtp_send_h263_class_init(MSRtpSendH263Class *klass);
void ms_rtp_send_h263_destroy( MSRtpSendH263 *obj);
void ms_rtp_send_h263_process(MSRtpSendH263 *r);
void ms_rtp_send_h263_setup(MSRtpSendH263 *r, MSSync *sync);

#endif
